global gObjects, gCursorlist, cNullCast, gObjectsH, gStates, gWorld, sQTCharSprite, gLastKeyList, gCurKeyList, gKeyRef, gHaveNavs, sPICTSPRITE, gEnvironmentSound

on fixName startcast, endcast
  set newName to "fdbcknoclog"
  repeat with X = startcast to endcast
    set nameOfCast to the name of cast X
    set loop to 1
    repeat while loop = 1
      if char 1 of nameOfCast = "." then
        exit repeat
      end if
      delete char 1 of nameOfCast
    end repeat
    put newName before nameOfCast
    set the name of cast X to string(nameOfCast)
    updateStage()
  end repeat
end

on castInScore startFrame, endFrame, numOfCast
  repeat with X = startFrame to endFrame
    go(X)
    repeat with z = 1 to 48
      if the castNum of sprite z = numOfCast then
        put "Cast number " & numOfCast & " is in sprite channel " & z & " of frame " & X
      end if
    end repeat
  end repeat
  put "••• FINISHED •••"
end

on giveCreds inAmount
  if integerp(inAmount) then
    setaProp(gStates, #Credits, integer(getaProp(gStates, #Credits) + inAmount))
  end if
  if (getaProp(gStates, #Credits) - getaProp(gStates, #Debt)) >= 15000 then
    MakeDynamic(#ShortTermStock, #solved, #true)
    setaProp(getaProp(gStates, #Conditions), #ShortStock, #true)
  end if
end

on EnterH01
  if voidp(getaProp(getaProp(gStates, #BeenThere), #H01)) then
    PDARelease("J06hosp.mov")
  end if
  checkOnEnterH()
end

on enterH04
  pickNurse(1)
end

on exitH04
  set NurseObj to getaProp(gObjects, #NurseVid)
  MakeDynamic(#NurseVid, #clickCount, 1)
  set curCond to getaProp(getaProp(gObjects, #NurseVid), #curCond)
  if getOne(getaProp(NurseObj, #condList), curCond) = 0 then
    set condList to getaProp(NurseObj, #condList)
    add(condList, curCond)
    MakeDynamic(#NurseVid, #condList, condList)
  end if
  MakeDynamic(#PaMonitor, #PINEntered, #empty)
end

on calcTransToH06 Test
  if Test = #Debug then
    return [#H06, #H06B]
  end if
  pickAgent(#H06)
  set agentStatus to getaProp(getaProp(gObjects, #Agent06vid), #DisplayState)
  if agentStatus = #OffScreen then
    return #H06
  else
    return #H06B
  end if
end

on enterH06B
  set gHaveNavs to #false
  Startthetimer(600, "handleAgentMovie06")
end

on exitH06B
  set gHaveNavs to #true
end

on handleAgentMovie06
  Startthetimer(the stopTime of sprite sQTCharSprite - the movieTime of sprite sQTCharSprite + 10, "jumpH06")
end

on jumpH06
  Jumptokey(#H06)
end

on calcTransToH07 Test
  if Test = #Debug then
    return [#H07, #H07B]
  end if
  pickAgent(#H07)
  set agentStatus to getaProp(getaProp(gObjects, #Agent07vid), #DisplayState)
  if agentStatus = #OffScreen then
    return #H07
  else
    return #H07B
  end if
end

on enterH07B
  set gHaveNavs to #false
  Startthetimer(600, "handleAgentMovie07")
end

on handleAgentMovie07
  Startthetimer(the stopTime of sprite sQTCharSprite - the movieTime of sprite sQTCharSprite + 10, "jumpH07")
end

on jumpH07
  Jumptokey(#H07)
end

on exitH07B
  set gHaveNavs to #true
end

on EnterH08
  if (getaProp(getaProp(gStates, #Conditions), #ShortStock) = #true) and (getaProp(gStates, #Debt) = 0) and (getaProp(getaProp(gObjects, #PaMonitor), #HospPaid) = #true) then
    setAt(getaProp(getaProp(gWorld, #H08), #GOWHERE), 1, #H17)
  else
    setAt(getaProp(getaProp(gWorld, #H08), #GOWHERE), 1, #empty)
  end if
end

on EnterH09
  doTextFldFormat()
  set Mobj to getaProp(gObjects, #PaMonitor)
  Startthetimer(30, "TurnPaMonitorON")
end

on exitH09
  playSound("H09monOn.aif", #keyframeCast)
  DoSetToOFF()
  if getaProp(getaProp(gObjects, #PaMonitor), #PINEntered) = #empty then
    MakeDynamic(#PaMonitor, #PINEntered, #false)
  end if
  MakeDynamic(#PaPatients, #whichPatient, 0)
end

on calcTranstoH11 Test
  if Test = #Debug then
    return [#H11B, #H11D]
  end if
  pickDoctor(1)
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #DisplayState)
  if (docState = #OffScreen) or (docState = #defibSolved1) then
    return #H11D
  else
    return #H11B
  end if
end

on enterH11B
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #DisplayState)
  if (docState = #shrtStckSlvd) or (docState = #heartSolved) then
    Startthetimer(60, "prepareNewH11BBkd", #Doc11Vid)
  end if
end

on enterH11D
  nothing()
end

on prepareNewH11BBkd
  Startthetimer(the stopTime of sprite sQTCharSprite - the movieTime of sprite sQTCharSprite + 6, "setNewH11BBkd", #Doc11Vid)
end

on setNewH11BBkd
  set the castNum of sprite sPICTSPRITE to the number of cast "H11D.PCT"
  DelObjects([#Doc11vidrect, #Doc11Vid])
end

on exitH11
  set doctorObj to getaProp(gObjects, #Doc11Vid)
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #DisplayState)
  if (docState = #shrtStckSlvd) or (docState = #heartSolved) or (docState = #messingUp) then
    set gKeyRef to #H11D
  end if
  MakeDynamic(#Doc11Vid, #clickCount, 1)
  set curCond to getaProp(getaProp(gObjects, #Doc11Vid), #curCond)
  if getOne(getaProp(doctorObj, #condList), curCond) = 0 then
    set condList to getaProp(doctorObj, #condList)
    add(condList, curCond)
    MakeDynamic(#Doc11Vid, #condList, condList)
    if curCond = #defibSolved2 then
      set curCond to #defibSolved1
      set condList to getaProp(doctorObj, #condList)
      add(condList, curCond)
      MakeDynamic(#Doc11Vid, #condList, condList)
    end if
  end if
  MakeDynamic(#Doc11vidrect, #Hotrect, [rect(318, 40, 558, 256)])
  MakeDynamic(#Doc11vidrect, #curCond, #empty)
end

on setDeath
  MakeDynamic(#Doc11Vid, #h12Count, 5)
end

on calcNavtoH12
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #State)
  if (docState = #Dead1) or (docState = #Dead2) or (docState = #Dead3) then
    stopsound("Hambient.aif")
    genexitkf(#HDie)
  else
    genexitkf(#H12)
  end if
end

on enterH12
  set doctorObj to getaProp(gObjects, #Doc11Vid)
  if getOne(getaProp(doctorObj, #Playlist), "H11dnd2.mov") <> 0 then
    set h12Count to getaProp(doctorObj, #h12Count) + 1
    MakeDynamic(#Doc11Vid, #h12Count, h12Count)
  end if
end

on exitH12
  DoTurnDefibOFF()
  MakeDynamic(#DefibPower, #State, #close)
end

on calcTranstoH13
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #State)
  if (docState = #Dead1) or (docState = #Dead2) or (docState = #Dead3) then
    stopsound("Hambient.aif")
    return #HDie
  else
    return #H13
  end if
end

on calcTranstoH20
  set docState to getaProp(getaProp(gObjects, #Doc11Vid), #State)
  if (docState = #Dead1) or (docState = #Dead2) or (docState = #Dead3) then
    stopsound("Hambient.aif")
    return #HDie
  else
    return #H20
  end if
end

on checkOnEnterH
  set doctorObj to getaProp(gObjects, #Doc11Vid)
  if getOne(getaProp(doctorObj, #Playlist), "H11dnd1.mov") <> 0 then
    if (getaProp(getaProp(gObjects, #TubeObj), #Aquired) <> #true) and (getaProp(getaProp(gObjects, #syrnObj), #Aquired) <> #true) then
      MakeDynamic(#Doc11Vid, #slippingCond, #true)
    end if
  end if
  if getOne(getaProp(doctorObj, #Playlist), "H11dps2.mov") <> 0 then
    MakeDynamic(#Doc11Vid, #messingUpCond, #true)
  end if
end
