on DoPakey KeyNum
  set currentPIN to field "PaPinText"
  if integerp(KeyNum) then
    if getaProp(getaProp(gObjects, #GasStation), #State) = #on then
      put string(KeyNum) after field "PaPinText"
      set charMax to 4
      if the number of chars in field "PaPinText" = charMax then
        setPaPINKeyState(#off)
      end if
    end if
  else
    if KeyNum = #enter then
      set validPIN to getaProp(getaProp(gObjects, #PaKeyPad), #validPIN)
      if currentPIN = validPIN then
        doValidHosPIN()
      else
        doInValidHosPIN()
      end if
    else
      if KeyNum = #delete then
        delete char -30000 of field "PaPinText"
        setPaPINKeyState(#on)
      end if
    end if
  end if
end

on doInValidHosPIN
  setPaPINKeyState(#off)
  Startthetimer(120, "doResetPINScreen")
end

on setPaPINKeyState setState
  if symbolp(setState) then
    MakeDynamic(#PaKeyPad, #State, setState)
  else
    put "bad parameter passed to setShortKeyBoardState"
  end if
end

on doValidHosPIN
  set whichPatient to getaProp(getaProp(gObjects, #PaPatients), #whichPatient)
  if whichPatient = 8 then
    set Credits to getaProp(gStates, #Credits)
    set NurseObj to getaProp(gObjects, #NurseVid)
    if getaProp(getaProp(gObjects, #PaMonitor), #HospPaid) <> #true then
      if Credits >= 15000 then
        MakeDynamic(#PaMonitor, #HospPaid, #true)
        setaProp(gStates, #Credits, integer(Credits - 15000))
        MakeDynamic(#NurseVid, #insufCreds, #false)
      else
        MakeDynamic(#NurseVid, #insufCreds, #true)
      end if
    end if
    DoPaStatusGO()
    doResetPINScreen()
  else
    setPaPINKeyState(#off)
    Startthetimer(120, "doResetPINScreen")
  end if
  MakeDynamic(#PaMonitor, #PINEntered, #true)
end

on doResetPINScreen
  put EMPTY into field "PaPinText"
  setPaPINKeyState(#on)
end
